﻿#SymbolCount = 12 ;0 based count
Global numw.l=1
Structure romanNumeral
  symbol.s 
  value.i
EndStructure

Global Dim refRomanNum.romanNumeral(#SymbolCount)

Enumeration;gadgets
  #p
  #f
  #s
EndEnumeration

Enumeration;menus
  #file_quit
  ;#file_open
  #file_num
  #opt_arab
  #opt_roman
EndEnumeration


Restore denominations
For i = 0 To #SymbolCount
  Read.s refRomanNum(i)\symbol
Next

Restore denomValues
For i = 0 To #SymbolCount
  Read refRomanNum(i)\value
Next  

Procedure.s decRoman(n)
  ;converts a decimal number to a roman numeral
  Protected roman$, i
  
  For i = 0 To #SymbolCount
    Repeat
      If n >= refRomanNum(i)\value
        roman$ + refRomanNum(i)\symbol
        n - refRomanNum(i)\value
      Else
        Break
      EndIf
    ForEver
  Next
  
  ProcedureReturn roman$
EndProcedure

Procedure setmnu()
  Select numw
    Case 1
      SetMenuItemState(0,#opt_arab,1)
      SetMenuItemState(0,#opt_roman,0)
    Case 2
      SetMenuItemState(0,#opt_arab,0)
      SetMenuItemState(0,#opt_roman,1)
    Default: MessageRequester("Options","unknown value:"+Str(numw))
  EndSelect
EndProcedure

;https://www.purebasic.fr/english/viewtopic.php?p=564647
flags = #PB_Window_SystemMenu| #PB_Window_MaximizeGadget| #PB_Window_MinimizeGadget| #PB_Window_ScreenCentered | #PB_Window_SizeGadget
If OpenWindow(0,0,0,640,480,"Numberer v0.1",Flags)
  
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    ;MenuItem(#file_open, "Open"   +Chr(9)+"Ctrl+O")
    MenuItem(#file_num, "Number!")
    MenuBar()
    MenuItem(#file_quit, "Quit")
    MenuTitle("Options")
    MenuItem(#opt_arab, "Arabic numbers")
    MenuItem(#opt_roman, "Roman Numbers")
  EndIf
  
  ContainerGadget(#p,0,0,640,460,#WS_CLIPSIBLINGS | #PB_Container_Flat)
  StringGadget(#f,0,20,640,440,"",#ES_MULTILINE|#ESB_DISABLE_BOTH)
  StringGadget(#s,0,0,640,20,". ")
  CloseGadgetList()
  GadgetToolTip(#s,"separator")
  GadgetToolTip(#f,"List lines")
  
  ;numw=1 ;number way: 1-arab,2-roman
  If OpenPreferences("num.ini")
    PreferenceGroup("options")
    numw=ReadPreferenceLong("number",1)
    s$=ReadPreferenceString("sepa",".")
    SetGadgetText(#s,s$)
    ClosePreferences()
  EndIf
  setmnu()
  
  SetActiveGadget(#f)
  ;;SetMenuItemState(0,#opt_arab,1)
  
  ;   t$=""
  ;   ReadFile(0,"stihi.txt")
  ;   While Not Eof(0)
  ;     t$=t$+ReadString(0,#PB_Ascii)+#CRLF$
  ;   Wend
  ; 
  ;   SetGadgetText(1,t$)
  ;   CloseFile(0)
  he=GadgetID(#f)
  
;   f$="stihi.txt"
;   fs=FileSize(f$)
;   *m=AllocateMemory(fs)
;   ReadFile(0,f$)
;   ReadData(0,*m,fs)
;   CloseFile(0)
;   SendMessage_(he,#WM_SETTEXT,0,*m)
;   
;   FreeMemory(*m)
  
  Repeat
    If GetAsyncKeyState_(#VK_ESCAPE)&32768
      Break
    EndIf
    
    Select WaitWindowEvent()
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_quit : Break
          Case #opt_arab
            ;             SetMenuItemState(0,#opt_arab,1)
            ;             SetMenuItemState(0,#opt_roman,0)
            numw=1
            setmnu()
          Case #opt_roman
            ;             SetMenuItemState(0,#opt_arab,0)
            ;             SetMenuItemState(0,#opt_roman,1)
            numw=2
            setmnu()
          Case #file_num
            t$=GetGadgetText(#f)
            ln=SendMessage_(he,#EM_GETLINECOUNT,0,0)
            s$=GetGadgetText(#s)
            SendMessage_(he,#EM_SETSEL,1,20)
            For i=0 To ln-1
              of=SendMessage_(he,#EM_LINEINDEX,i,0)
              SendMessage_(he,#EM_SETSEL,of,of)
              Select numw
                Case 1
                  n$=Str(i+1)+s$
                Case 2
                  n$=decRoman(i+1)+s$
              EndSelect
              ;n$=Str(i+1)+s$
              SendMessage_(he,#EM_REPLACESEL,1,n$)
            Next i
            
            
            
        EndSelect
        
      Case #PB_Event_CloseWindow
        Break
    EndSelect
  ForEver
  ;write options
  If FileSize("num.ini")>0
    If CreatePreferences("num.ini")
      PreferenceGroup("options")
      WritePreferenceLong("number",numw)
      WritePreferenceString("sepa",GetGadgetText(#s))
      ClosePreferences()
    Else
      MessageRequester("num.ini","Cannot create file!")
    EndIf
  EndIf
  
EndIf

DataSection
  denominations:
  Data.s "M","CM","D","CD","C","XC","L","XL","X","IX","V","IV","I" ;0-12
  
  denomValues:
  Data.i  1000,900,500,400,100,90,50,40,10,9,5,4,1 ;values in decending sequential order
EndDataSection

; IDE Options = PureBasic 5.30 (Windows - x86)
; Folding = -
; EnableXP
; UseIcon = num.ico
; Executable = numb0_1.exe